/* 
 * Programa para armazenar informacoes sobre livros
 * Moacir A Ponti - ICMC/USP 2020
 * > demonstrando como structs e arrays funcionam e quando usá-las
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void entrada_livro(char* etitulo, char* eautor, unsigned short* eano, float* epreco) {
	printf("Titulo: ");
	fgets(etitulo, 120, stdin); // 120 bytes - 1 
       	etitulo[ strlen(etitulo)-1 ] = '\0';	

	printf("Ano: ");
	scanf("%hu", eano);
	getchar(); // consome o \n antes do fgets

	printf("Autor: ");
	fgets(eautor, 120, stdin); // 120 bytes - 1 
       	eautor[ strlen(eautor)-1 ] = '\0';

	printf("Preco: ");
	scanf("%f", epreco); 

}


int main (void) {
	
	// Livro:
	// Titulo, Ano

	unsigned short ano; // 2 bytes na memória stack - cada byte tem um endereco
			    //	os enderecos sao transparentes ao programador que utiliza a stack
	char titulo[120]; // 120 bytes, todos serao interpretados como char, ou seja de 1 em 1
	char autor[60];
	float preco;
	unsigned int n_pag;
	unsigned char edicao;

	unsigned short* end_varus;

	entrada_livro(titulo, autor, &ano, &preco);

	printf("Informacao Digitada:\n");
	end_varus = &ano;
	printf("Titulo: %s (está no endereco iniciando em %p)\n", titulo, &titulo);
	printf("Ano: %hu (está no endereco iniciando em %p)\n", ano, end_varus);
	printf("Autor: %s (está no endereco iniciando em %p)\n", autor, &autor);
	printf("Preco: %s (está no endereco iniciando em %p)\n", preco, &preco);

	return 0;
}
